unit KclEditors;

interface

uses
  DesignIntf, DesignEditors, VCLEditors,
  Classes, Sysutils, dialogs, TypInfo, graphics, forms, buttons, extctrls, stdctrls,
  controls, messages, menus, comctrls;

type
  TKclCaptionProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

  TKclImageEditor = class(TComponentEditor)
  public
    procedure Edit; override;
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

implementation

uses
  CaptionEditForm, KclPicEdit;

{ TKclCaptionProperty }

procedure TKclCaptionProperty.Edit;
var
  S: string;
begin
  //inherited;
  S := Self.GetStrValue;
  CaptionEditor.Execute(S);
  S := CaptionEditor.CaptionStr;
  Self.SetValue(S);
end;

function TKclCaptionProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paMultiSelect]; 
end;

{ TKclImageEditor }

procedure TKclImageEditor.Edit;
begin
  //inherited;
  ExecuteVerb(0);
end;

procedure TKclImageEditor.ExecuteVerb(Index: Integer);
var
  PictureEditor: TPictureEditor;
begin
  //inherited;
  if Index = 0 then
  begin
    PictureEditor := TPictureEditor.Create(nil);
    try
      PictureEditor.Picture := TPicture(TImage(Component).Picture);
      if PictureEditor.Execute then
        TImage(Component).Picture := PictureEditor.Picture;
        //SetOrdValue(Longint(PictureEditor.Picture));
    finally
      PictureEditor.Free;
    end;
  end;
end;

function TKclImageEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0 then
    Result := 'Set Image...';
end;

function TKclImageEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

end.
 